diff --git a/README.md b/README.md
index 83d738fb..0e5c956b 100644
--- a/README.md
+++ b/README.md
@@ -1126,6 +1126,30 @@ ________________________________________________________________________________
+
+ 🔸CasaOS LXC
+
+
+
+ CasaOS LXC
+
+[CasaOS](https://www.casaos.io/) is a community-based open source software focused on delivering simple home cloud experience around Docker ecosystem.
+
+
+To create a new Proxmox CasaOS LXC, run the following in the Proxmox Shell.
+
+```
+bash -c "$(wget -qLO - https://github.com/tteck/Proxmox/raw/main/ct/CasaOS-v4.sh)"
+```
+
+âš¡ Default Settings: 2GB RAM - 8GB Storage - 2vCPU âš¡
+
+**CasaOS Interface - IP**
+
+____________________________________________________________________________________________
+
+
+
Debian LXC
diff --git a/ct/casaos-v4.sh b/ct/casaos-v4.sh
new file mode 100644
index 00000000..4f6509a5
--- /dev/null
+++ b/ct/casaos-v4.sh
@@ -0,0 +1,270 @@
+#!/usr/bin/env bash
+echo -e "Loading..."
+APP="CasaOS"
+var_disk="8"
+var_cpu="2"
+var_ram="2048"
+var_os="debian"
+var_version="11"
+NSAPP=$(echo ${APP,,} | tr -d ' ')
+var_install="${NSAPP}-install"
+NEXTID=$(pvesh get /cluster/nextid)
+INTEGER='^[0-9]+$'
+YW=`echo "\033[33m"`
+BL=`echo "\033[36m"`
+RD=`echo "\033[01;31m"`
+BGN=`echo "\033[4;92m"`
+GN=`echo "\033[1;92m"`
+DGN=`echo "\033[32m"`
+CL=`echo "\033[m"`
+BFR="\\r\\033[K"
+HOLD="-"
+CM="${GN}✓${CL}"
+set -o errexit
+set -o errtrace
+set -o nounset
+set -o pipefail
+shopt -s expand_aliases
+alias die='EXIT=$? LINE=$LINENO error_exit'
+trap die ERR
+function error_exit() {
+ trap - ERR
+ local reason="Unknown failure occurred."
+ local msg="${1:-$reason}"
+ local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
+ echo -e "$flag $msg" 1>&2
+ exit $EXIT
+}
+if (whiptail --title "${APP} LXC" --yesno "This will create a New ${APP} LXC. Proceed?" 10 58); then
+ echo "User selected Yes"
+else
+ clear
+ echo -e "âš User exited script \n"
+ exit
+fi
+function header_info {
+cat << "EOF"
+ ______ ____ _____
+ / ____/___ __v4______ _/ __ \/ ___/
+ / / / __ `/ ___/ __ `/ / / /\__ \
+/ /___/ /_/ (__ ) /_/ / /_/ /___/ /
+\____/\__,_/____/\__,_/\____//____/
+
+EOF
+}
+function msg_info() {
+ local msg="$1"
+ echo -ne " ${HOLD} ${YW}${msg}..."
+}
+function msg_ok() {
+ local msg="$1"
+ echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
+}
+function PVE_CHECK() {
+ PVE=$(pveversion | grep "pve-manager/7" | wc -l)
+if [[ $PVE != 1 ]]; then
+ echo -e "${RD}This script requires Proxmox Virtual Environment 7.0 or greater${CL}"
+ echo -e "Exiting..."
+ sleep 2
+ exit
+fi
+}
+function default_settings() {
+ echo -e "${DGN}Using ${var_os} Version: ${BGN}${var_version}${CL}"
+ echo -e "${DGN}Using Container Type: ${BGN}Unprivileged${CL} ${RD}NO DEVICE PASSTHROUGH${CL}"
+ CT_TYPE="1"
+ echo -e "${DGN}Using Root Password: ${BGN}Automatic Login${CL}"
+ PW=""
+ echo -e "${DGN}Using Container ID: ${BGN}$NEXTID${CL}"
+ CT_ID=$NEXTID
+ echo -e "${DGN}Using Hostname: ${BGN}$NSAPP${CL}"
+ HN=$NSAPP
+ echo -e "${DGN}Using Disk Size: ${BGN}$var_disk${CL}${DGN}GB${CL}"
+ DISK_SIZE="$var_disk"
+ echo -e "${DGN}Allocated Cores ${BGN}$var_cpu${CL}"
+ CORE_COUNT="$var_cpu"
+ echo -e "${DGN}Allocated Ram ${BGN}$var_ram${CL}"
+ RAM_SIZE="$var_ram"
+ echo -e "${DGN}Using Bridge: ${BGN}vmbr0${CL}"
+ BRG="vmbr0"
+ echo -e "${DGN}Using Static IP Address: ${BGN}dhcp${CL}"
+ NET=dhcp
+ echo -e "${DGN}Using Gateway Address: ${BGN}Default${CL}"
+ GATE=""
+ echo -e "${DGN}Using MAC Address: ${BGN}Default${CL}"
+ MAC=""
+ echo -e "${DGN}Using VLAN Tag: ${BGN}Default${CL}"
+ VLAN=""
+ echo -e "${BL}Creating a ${APP} LXC using the above default settings${CL}"
+}
+function advanced_settings() {
+var_version=$(whiptail --title "DEBIAN VERSION" --radiolist "Choose Version" 10 58 2 \
+"10" "Buster" OFF \
+"11" "Bullseye" ON \
+3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ echo -e "${DGN}Using Debian Version: ${BGN}$var_version${CL}"
+else
+ exit
+fi
+CT_TYPE=$(whiptail --title "CONTAINER TYPE" --radiolist "Choose Type" 8 58 2 \
+"1" "Unprivileged" ON \
+"0" "Privileged" OFF \
+3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ echo -e "${DGN}Using Container Type: ${BGN}$CT_TYPE${CL}"
+else
+ exit
+fi
+PW1=$(whiptail --inputbox "Set Root Password" 8 58 --title "PASSWORD(leave blank for automatic login)" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ if [ -z $PW1 ]; then PW1="Automatic Login" PW=" ";
+ echo -e "${DGN}Using Root Password: ${BGN}$PW1${CL}"
+else
+ PW="-password $PW1"
+ echo -e "${DGN}Using Root Password: ${BGN}$PW1${CL}"
+ fi
+fi
+CT_ID=$(whiptail --inputbox "Set Container ID?" 8 58 $NEXTID --title "CONTAINER ID" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ echo -e "${DGN}Using Container ID: ${BGN}$CT_ID${CL}"
+else
+ exit
+fi
+CT_NAME=$(whiptail --inputbox "Set Hostname" 8 58 $NSAPP --title "HOSTNAME" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ HN=$(echo ${CT_NAME,,} | tr -d ' ')
+ echo -e "${DGN}Using Hostname: ${BGN}$HN${CL}"
+else
+ exit
+fi
+DISK_SIZE=$(whiptail --inputbox "Set Disk Size in GB" 8 58 $var_disk --title "DISK SIZE" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ echo -e "${DGN}Using Disk Size: ${BGN}$DISK_SIZE${CL}"
+ if ! [[ $DISK_SIZE =~ $INTEGER ]] ; then echo -e "${RD}âš DISK SIZE MUST BE A INTEGER NUMBER!${CL}"; advanced_settings; fi;
+else
+ exit
+fi
+CORE_COUNT=$(whiptail --inputbox "Allocate CPU Cores" 8 58 $var_cpu --title "CORE COUNT" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ echo -e "${DGN}Allocated Cores: ${BGN}$CORE_COUNT${CL}"
+else
+ exit
+fi
+RAM_SIZE=$(whiptail --inputbox "Allocate RAM in MiB" 8 58 $var_ram --title "RAM" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ echo -e "${DGN}Allocated RAM: ${BGN}$RAM_SIZE${CL}"
+else
+ exit
+fi
+BRG=$(whiptail --inputbox "Set a Bridge" 8 58 vmbr0 --title "BRIDGE" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ echo -e "${DGN}Using Bridge: ${BGN}$BRG${CL}"
+else
+ exit
+fi
+NET=$(whiptail --inputbox "Set a Static IPv4 CIDR Address(/24)" 8 58 dhcp --title "IP ADDRESS" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ echo -e "${DGN}Using IP Address: ${BGN}$NET${CL}"
+else
+ exit
+fi
+GATE1=$(whiptail --inputbox "Set a Gateway IP (mandatory if Static IP was used)" 8 58 --title "GATEWAY IP" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ if [ -z $GATE1 ]; then GATE1="Default" GATE="";
+ echo -e "${DGN}Using Gateway IP Address: ${BGN}$GATE1${CL}"
+else
+ GATE=",gw=$GATE1"
+ echo -e "${DGN}Using Gateway IP Address: ${BGN}$GATE1${CL}"
+ fi
+fi
+MAC1=$(whiptail --inputbox "Set a MAC Address(leave blank for default)" 8 58 --title "MAC ADDRESS" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ if [ -z $MAC1 ]; then MAC1="Default" MAC="";
+ echo -e "${DGN}Using MAC Address: ${BGN}$MAC1${CL}"
+else
+ MAC=",hwaddr=$MAC1"
+ echo -e "${DGN}Using MAC Address: ${BGN}$MAC1${CL}"
+ fi
+fi
+VLAN1=$(whiptail --inputbox "Set a Vlan(leave blank for default)" 8 58 --title "VLAN" 3>&1 1>&2 2>&3)
+exitstatus=$?
+if [ $exitstatus = 0 ]; then
+ if [ -z $VLAN1 ]; then VLAN1="Default" VLAN="";
+ echo -e "${DGN}Using Vlan: ${BGN}$VLAN1${CL}"
+else
+ VLAN=",tag=$VLAN1"
+ echo -e "${DGN}Using Vlan: ${BGN}$VLAN1${CL}"
+ fi
+fi
+if (whiptail --title "ADVANCED SETTINGS COMPLETE" --yesno "Ready to create ${APP} LXC?" 10 58); then
+ echo -e "${RD}Creating a ${APP} LXC using the above advanced settings${CL}"
+else
+ clear
+ header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ advanced_settings
+fi
+}
+function start_script() {
+if (whiptail --title "SETTINGS" --yesno "Use Default Settings?" 10 58); then
+ header_info
+ echo -e "${BL}Using Default Settings${CL}"
+ default_settings
+else
+ header_info
+ echo -e "${RD}Using Advanced Settings${CL}"
+ advanced_settings
+fi
+}
+clear
+start_script
+if [ "$CT_TYPE" == "1" ]; then
+ FEATURES="nesting=1,keyctl=1"
+ else
+ FEATURES="nesting=1"
+ fi
+TEMP_DIR=$(mktemp -d)
+pushd $TEMP_DIR >/dev/null
+export CTID=$CT_ID
+export PCT_OSTYPE=$var_os
+export PCT_OSVERSION=$var_version
+export PCT_DISK_SIZE=$DISK_SIZE
+export PCT_OPTIONS="
+ -features $FEATURES
+ -hostname $HN
+ -net0 name=eth0,bridge=$BRG$MAC,ip=$NET$GATE$VLAN
+ -onboot 1
+ -cores $CORE_COUNT
+ -memory $RAM_SIZE
+ -unprivileged $CT_TYPE
+ $PW
+"
+bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/ct/create_lxc.sh)" || exit
+LXC_CONFIG=/etc/pve/lxc/${CTID}.conf
+cat <> $LXC_CONFIG
+lxc.cgroup2.devices.allow: a
+lxc.cap.drop:
+EOF
+msg_info "Starting LXC Container"
+pct start $CTID
+msg_ok "Started LXC Container"
+lxc-attach -n $CTID -- bash -c "$(wget -qLO - https://raw.githubusercontent.com/tteck/Proxmox/main/setup/$var_install.sh)" || exit
+IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}')
+pct set $CTID -description "# ${APP} LXC
+### https://tteck.github.io/Proxmox/"
+msg_ok "Completed Successfully!\n"
+echo -e "${APP} Setup should be reachable by going to the following URL.
+ ${BL}http://${IP} ${CL} \n"
diff --git a/setup/casaos-install.sh b/setup/casaos-install.sh
new file mode 100644
index 00000000..634a00e7
--- /dev/null
+++ b/setup/casaos-install.sh
@@ -0,0 +1,111 @@
+#!/usr/bin/env bash
+YW=`echo "\033[33m"`
+RD=`echo "\033[01;31m"`
+BL=`echo "\033[36m"`
+GN=`echo "\033[1;92m"`
+CL=`echo "\033[m"`
+RETRY_NUM=10
+RETRY_EVERY=3
+NUM=$RETRY_NUM
+CM="${GN}✓${CL}"
+CROSS="${RD}✗${CL}"
+BFR="\\r\\033[K"
+HOLD="-"
+set -o errexit
+set -o errtrace
+set -o nounset
+set -o pipefail
+shopt -s expand_aliases
+alias die='EXIT=$? LINE=$LINENO error_exit'
+trap die ERR
+
+function error_exit() {
+ trap - ERR
+ local reason="Unknown failure occurred."
+ local msg="${1:-$reason}"
+ local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
+ echo -e "$flag $msg" 1>&2
+ exit $EXIT
+}
+
+function msg_info() {
+ local msg="$1"
+ echo -ne " ${HOLD} ${YW}${msg}..."
+}
+
+function msg_ok() {
+ local msg="$1"
+ echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
+}
+
+function msg_error() {
+ local msg="$1"
+ echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
+}
+
+msg_info "Setting up Container OS "
+sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
+locale-gen >/dev/null
+while [ "$(hostname -I)" = "" ]; do
+ 1>&2 echo -en "${CROSS}${RD} No Network! "
+ sleep $RETRY_EVERY
+ ((NUM--))
+ if [ $NUM -eq 0 ]
+ then
+ 1>&2 echo -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
+ exit 1
+ fi
+done
+msg_ok "Set up Container OS"
+msg_ok "Network Connected: ${BL}$(hostname -I)"
+
+if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; else msg_error "Internet NOT Connected"; exit 1; fi;
+RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
+if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi;
+
+msg_info "Updating Container OS"
+apt-get update &>/dev/null
+apt-get -y upgrade &>/dev/null
+msg_ok "Updated Container OS"
+
+msg_info "Installing Dependencies"
+apt-get install -y curl &>/dev/null
+apt-get install -y sudo &>/dev/null
+apt-get install -y unzip &>/dev/null
+msg_ok "Installed Dependencies"
+
+DOCKER_CONFIG_PATH='/etc/docker/daemon.json'
+mkdir -p $(dirname $DOCKER_CONFIG_PATH)
+cat >$DOCKER_CONFIG_PATH <<'EOF'
+{
+ "log-driver": "journald"
+}
+EOF
+
+msg_info "Installing CasaOS (Patience)"
+wget -qO- https://get.casaos.io | bash &>/dev/null
+msg_ok "Installed CasaOS"
+
+PASS=$(grep -w "root" /etc/shadow | cut -b6);
+ if [[ $PASS != $ ]]; then
+msg_info "Customizing Container"
+rm /etc/motd
+rm /etc/update-motd.d/10-uname
+touch ~/.hushlogin
+GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
+mkdir -p $(dirname $GETTY_OVERRIDE)
+cat << EOF > $GETTY_OVERRIDE
+[Service]
+ExecStart=
+ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
+EOF
+systemctl daemon-reload
+systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
+msg_ok "Customized Container"
+ fi
+
+msg_info "Cleaning up"
+apt-get autoremove >/dev/null
+apt-get autoclean >/dev/null
+rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
+msg_ok "Cleaned"